-- XTimestamp by Xzandro
XT = {}

function XT.init(eventCode, addOnName)
    if addOnName ~= "XTimestamp" then
        return
    end
    d("XTimestamp loaded")
    ZO_ChatSystem_AddEventHandler(EVENT_CHAT_MESSAGE_CHANNEL, XT.handleChat)
end

function XT.handleChat(messageType, fromName, text)
    local ChannelInfo = ZO_ChatSystem_GetChannelInfo()
    local channelInfo = ChannelInfo[messageType]
    if channelInfo and channelInfo.format then
        local chattime = "["..GetTimeString().."] ";
        local channelLink = XT.CreateChannelLink(channelInfo)
        local fromLink = XT.CreateFromLink(fromName, channelInfo)
        if channelLink then
            return chattime..zo_strformat(channelInfo.format, channelLink, fromLink, text), channelInfo.saveTarget
        end
        return chattime..zo_strformat(channelInfo.format, fromLink, text), channelInfo.saveTarget
    end
end

function XT.CreateChannelLink(channelInfo, overrideName)
    if channelInfo.channelLinkable then
        local channelName = overrideName or GetChannelName(channelInfo.id)
        return ZO_LinkHandler_CreateChannelLink(channelName)
    end
end

function XT.CreateFromLink(fromName, channelInfo)
    if channelInfo.playerLinkable then
       return ZO_LinkHandler_CreatePlayerLink(fromName)
    end
    return fromName
end

function XT.print(msg)
    d("XTimestamp: " .. msg)
end

EVENT_MANAGER:RegisterForEvent("XTimestamp", EVENT_ADD_ON_LOADED, XT.init)